
-- return the window size
getWindowSize = getWindowSize or function()
	return 673, 217
end

-- create and lay out all the controls
createUI = createUI or function()

	createUICommon()
	setBannerContent( "nameOnly", 20, 200 )

	-- constants
	local kKnobSpace = 48
	local kKnobSpaceV = 70
	local kLabelSpaceV = 30
	local kWideTextW = 57
	local kEnvW = 120
	local kEnvH = 70

	local function wideKnobAndTextField( group, param, label, x, y )
		knobAndTextField( group, param, label, x, y, kKnobSize, kTextFieldH, kWideTextW )
	end

	-- make groups and knobs
	--
	
	local x = 0

	theKnobRenderer = smallKnobRenderer

	oscGroup = group( "OSC" )
	smallKnobAndTextField( oscGroup, "OSC Port Offset",	"Port",		0*kKnobSpace, 0 )
	oscGroup:setVisible( false )

	dinGroup = group( "Setup" )
	x = 0
	y = 0
	y = y + kKnobSpaceV
	labelledDropDown( dinGroup, "DINsync Type", "Type",				x, y+kLabelSpaceV )
	labelledDropDown( dinGroup, "Divisor", "Divisor",		x, y )
	dinGroup:add( paramButton( "1st Delay", "1st Delay",	x, y-kLabelSpaceV, kDropdownW, kTextFieldH ) )
	dinGroup:add( paramButton( "Skip First Clock", "Skip 1st",	x, y-kLabelSpaceV-kTextFieldH-5, kDropdownW, kTextFieldH ) )
	x = x + kDropdownW+10
	smallKnobAndTextField( dinGroup, "PPQN",	"PPQN",	x, y )
	x = x + kKnobSpace
	smallKnobAndTextField( dinGroup, "Multiplier",	"Multiplier",	x, y )
	x = x + kKnobSpace + pad
	x = 0
	y = 0
	labelledDropDown( dinGroup, "Swing Type", "Swing",		x, y )
	x = x + kDropdownW+10
	smallKnobAndTextField( dinGroup, "Swing",	"Swing",	x, y )
	x = x + kKnobSpace
	smallKnobAndTextField( dinGroup, "Offset",	"Offset",	x, y )
	x = x + kKnobSpace + pad

	clockGroup = group( "Clock Signal" )
	x = 0
	y = 0
	wideKnobAndTextField( clockGroup, "Clock Output",	"Clck Output",		x, y )
	x = x + kWideTextW + pad
	wideKnobAndTextField( clockGroup, "Clock Low",	"Clck Low",		x, y )
	x = x + kWideTextW + pad
	wideKnobAndTextField( clockGroup, "Clock High",	"Clck High",	x, y )
	x = x + kWideTextW + pad
	smallKnobAndTextField( clockGroup, "Trigger Length",	"Trigger",	x, y )
	x = x + kKnobSpace
	clockGroup:add( paramButton( "Mute Clocks",	"Mute",	x-5, y, kKnobSize+10, 20 ) )
	x = x + kKnobSpace
	clockGroup:add( paramButton( "Enable FSK",	"FSK",	x-5, y, kKnobSize+10, 20 ) )
	x = x + kKnobSpace

	runGroup = group( "Run Signal" )
	x = 0
	y = 0
	wideKnobAndTextField( runGroup, "Run Output",	"Run Output",		x, y )
	x = x + kWideTextW + pad
	wideKnobAndTextField( runGroup, "Run Low",		"Run Low",	x, y )
	x = x + kWideTextW + pad
	wideKnobAndTextField( runGroup, "Run High",	"Run High",	x, y )
	x = x + kWideTextW + pad
	smallKnobAndTextField( runGroup, "Run Trigger Length",	"Length",	x, y )
	x = x + kKnobSpace
	labelledDropDown( runGroup, "Run Signal Type", "Type",		x, y )
	labelledDropDown( runGroup, "Run Beat Divisor", "Divisor",	x, y+kLabelSpaceV )
	x = x + kDropdownW+10
	smallKnobAndTextField( runGroup, "Run Beats",	"Beats",	x, y )
	x = x + kKnobSpace

	hardwareGroup = group( "Hardware" )
	x = 0
	y = 0
	labelledDropDown( hardwareGroup, "ES Hardware Mode", "Mode",		x, y )

	interfaceGroup = group( "Interface" )
	x = 0
	labelledDropDown( interfaceGroup, "Interface Category", "Category",		x, 0 )

	-- positions!

	local xbase = windowEdgePad
	local ybase = windowEdgePad
	local x = xbase
	local y = ybase

	x = xbase

	dinGroup:setPosition( x, y, true )
	x = x + dinGroup:width() + pad

	runGroup:setPosition( x, y, true )
	y = y + runGroup:height() + pad

	clockGroup:setPosition( x, y, true )
	x = x + runGroup:width() + pad

	y = ybase
	hardwareGroup:setPosition( x, y, true )
	y = y + hardwareGroup:height() + pad

	interfaceGroup:setPosition( x, y, true )

	oscGroup:setPosition( x, y, true )
	x = x + oscGroup:width() + pad

	-- add directly positioned objects
	--

	if showLogicIndicators then
		local ww, wh = getWindowSize()
		local prefsW = kKnobSize+20
		local prefsH = 25
		local prefsX = ww-prefsW-windowEdgePad
		local logicH = 15
		add( propertyButton( 64140, "Logic", "In Logic Mode?", "indicator", prefsX, wh-prefsH-windowEdgePad-logicH-pad, prefsW, logicH ) )
	end

end		-- of createUI()
